# Roo Code 3.15.2 Release Notes (2025-05-02)

This release updates the Boomerang Orchestrator mode, improves Mermaid diagram rendering and error handling, enhances terminal performance, adds provider configuration options, and includes various UI fixes.

## Boomerang Orchestrator Mode

*   Enhanced [Orchestrator (Boomerang) mode](/features/boomerang-tasks) strictly orchestrates tasks.
*   No longer reads, writes, executes commands, or utilizes MCP servers; offloads these tasks to other modes.
*   Provides more predictable and secure task automation.

## Inline Mermaid Rendering

*   Made troubleshooting easier with clearer, multi-language error messages instead of displaying the invalid Mermaid markdown inline.
*   Added a convenient button to copy the diagram code for fixing or sharing.

    <img src="/img/v3.15.2/v3.15.2.png" alt="Mermaid diagram error message with copy code button" width="600" />

## Terminal Performance

*   **Improved Terminal Performance and Responsiveness**
    *   Made the integrated terminal significantly faster and smoother.
    *   Improved the reliability of stopping commands, especially for noisy processes.   

## Provider

*   **Added Custom OpenAI API Base URL Support**
    *   Enabled users in restricted regions or with custom infrastructure to connect to OpenAI services.
    *   Added a new configuration option in settings (thanks gongzhongqiang!).

*   **Added Custom Header Support for OpenAI-Compatible Providers**
    *   Increased flexibility by allowing custom headers to be added, edited, or removed directly in settings.
    *   Simplifies configuration for specific provider requirements (thanks mrubens!).

## Misc UI Improvements

*   **Fixed Chat Input Height Instability**
    *   Resolved an issue where the chat input box height could jump unexpectedly when resizing the Roo Code window.
    *   Provides a more stable and less distracting chat experience (thanks zhangtony239!).
*   **Corrected Chat Layout Padding Issues**
    *   Fixed padding calculations that caused awkward spacing or visual glitches when resizing the window.
    *   Ensures a cleaner and more visually consistent interface at any size (thanks zhangtony239!).
*   **Refined Inline Code Styling in Chat**
    *   Made technical discussions clearer and more comfortable to read with a smaller font and subtler border.
    *   Reduces visual clutter (thanks dicharkan!).
*   **Clarified Tool Group Display in Modes View**
    *   Explicitly displays 'None' when a mode has no associated tool groups, avoiding ambiguity.